char* ut2hrt(double t){
	static char dst[50];
	time_t tt;
	struct tm *pt;
	tt=t;
	t-=tt;
	pt=localtime(&tt);
	t+=pt->tm_sec;
	sprintf(dst,"%02d.%02d.%04d %02d:%02d:%09.6lf",
		pt->tm_mday,pt->tm_mon+1,pt->tm_year+1900,
		pt->tm_hour,pt->tm_min,t);
	return dst;
}


void statusOut(const char* st){
	strcpy(main_win->view->statusText,st);
	main_win->status->redraw_label();
}

typedef struct FILTER
 {
 char ext[20];
 char name[30];
 char konverter[300];
 char konfig[300];
 struct FILTER *next;
 } FILTER, *PFILTER;

FILTER *Filter=NULL;

int loadDefaults(myView *v){
	/* alle Variablen auf Standardwerte einstellen */
	v->sizeFont=12;
	v->Stacked=0;
	v->left=0;v->top=0;v->right=800;v->bottom=600;
	v->ColumnCount=2;v->LineCount=0;v->Pairmode=0;v->Zeitformat=0;
	v->littlestep=3600;v->bigstep=3600*24;v->aktstift=-1;
	v->MouseXscroll=50;v->MouseYscroll=10;v->separator=';';
	v->Stackpointer=0;v->Stackfuel=0;v->Testmode=0;v->Timer=0,
	v->Refreshtime=0;v->Refreshcounter=0;v->TempVerfall=1000000;
	v->AutoPrint=0;
	v->HeadLines=1;
	v->InvalidValue=0;
	v->Scale=60,v->offset=0;
	v->Zoom=360;
	v->PsResolution=72;
	v->selectedChan=-1;
	strcpy(v->DefUnit,"ERL");
	return 0;
}

int ReadLine(char* st, myView *v)
 {
  char ch;
  int c;
  do
   {
   c=0;
   do
    {
    ch=getc(v->file);
    if((ch==',')&&(v->separator!=',')) ch='.';
    if(ch=='\n') ch=0;
    if((ch!='"')&&(ch>31))
     {
     st[c]=ch;
     c++;
     }
    }
    while((ch)&&(!feof(v->file))&&(c<MAXLINELENGTH-2));
    st[c]=0;
   }
   while((!feof(v->file)&&st[0]=='#'));
  return 0;
 }

int RewindFile(myView *v)
 {
 char st1[MAXLINELENGTH];
 int a,c;
 a=v->HeadLines;
 if(a<0) a=0-a;
 rewind(v->file);
 while(a)
  {
   ReadLine(st1,v);	/* Kopfzeilen entfernen */
   a--;
  }
 return 0;
 }


/* liefert den nächsten Messwert */
float parse(char **cp,float alt,myView *v)
 {
 float reslt=alt;
 char *cp2;
 if(!(*cp)) return 0;
 cp2=strchr(*cp,v->separator);
 if(cp2) *cp2=0;
// if(!strlen(*cp)) return alt;	/* leeres feld: altwert */
 if(strstr(*cp,"#IN"))
  {
  reslt=0;
  v->InvalidValue=1;
  }
 else
  {
  sscanf(*cp,"%f",&reslt);
  v->InvalidValue=0;
  }
 if(cp2) *cp=cp2+1; else *cp=NULL;
 return reslt;
 }

/* Zeitstempel lesen */
double ReadTime(char *st,char **rp,myView *v)
{
 int monat,jahr;
 struct tm t;
 time_t tt;
 double zeit,sec=0;
 char *cp;
 /* Kommas in der Zeile durch Punkte ersetzen */
 cp=st;
 if(v->separator!=',') while (cp=strchr(cp,',')) *cp='.';
 if(cp=strchr(st,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/

 switch(v->Zeitformat)
 {
 case 1: /* Unixzeit Sekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit;
  }
 case 2: /* Unixzeit Millisekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit/1000;
  }
 case 3: /* Unixzeit Mikrosekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit/1000000;
  }
 case 4: /* Unixzeit Nanosekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit/1000000000;
  }
 default:
  {
  memset(&t,0,sizeof(t));
  sscanf(st,v->Filterstring,&t.tm_mday,&monat,&jahr,
		  &t.tm_hour,&t.tm_min,&sec);
  t.tm_sec=0; /* werden später addiert */
  t.tm_mon=monat-1;
  t.tm_year=jahr-1900;
  t.tm_isdst=-1;
  tt=mktime(&t);
  zeit=tt;	/* ganzzahliger Teil */
  zeit=zeit+sec;
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  cp=strchr(st,v->separator);
  if(cp) cp=strchr(cp+1,v->separator);
  if(cp) *rp=cp+1; else *rp=0;
  return zeit;
  }
 }
}

int FileClose(myView *v)
 {
 FILE *datei1;	/* ini-Datei */
 char st1[300];

 /* Einstellungen speichern */
 //datei1=fopen(v->IniFileName,"w");
 //ConfigSaveFile(datei1);

 if(v->file)
  {
  v->Stackfuel=0;
  fclose(v->file);
  v->file=0;
  }
  v->columns=0;
  if(v->column) free(v->column);
  memset(v,0,sizeof(myView));
  loadDefaults(v);
  statusOut("keine Datei geladen!");
 return 0;
 }


int AutoScale(int Set,myView *v)
 {
 char st1[MAXLINELENGTH],*cp;
 int a,c=0,Mantisse,Exponent;
 double minimum=1e10,minimum0,maximum=-1e10,x;
 double t1,laenge;

 if(!v->file) return 0;
 v->LineCount=0;
 v->Endzeit=DBL_MIN;
 v->Startzeit=DBL_MAX;
 sprintf(v->Filterstring,"%%d.%%d.%%d%c%%d:%%d:%%lf",v->separator);
 RewindFile(v);
 statusOut("Minima/Maxima werden gesucht, bitte warten!");
 do
  {
   ReadLine(st1,v);
   if((!feof(v->file))&&(strlen(st1)>12))
   {
   v->LineCount++;
   t1=ReadTime(st1,&cp,v);
   if (t1>v->Endzeit) v->Endzeit=t1;
   if (t1<v->Startzeit) v->Startzeit=t1;

   /* Maxima suchen */
    for(a=0;a<v->columns;a++)
     {
     x=parse(&cp,0,v); /*weiterzählen*/
      if(v->column[a].active)
       {
       if(x<minimum) minimum=x;
       if(x>maximum) maximum=x;
       }
     }
    c++;
    }
  }
  while(!feof(v->file));
  RewindFile(v);
  minimum0=minimum;
 //fl_alert("Scale=%f, Offset=%f, Startzeit=%lf, Endzeit=%lf, %d Zeilen gelesen, Max=%lf, Min=%lf",v->Scale,v->offset,v->Startzeit,v->Endzeit,v->LineCount,maximum,minimum);
 if(!c)
  {
  statusOut("In der Datei sind keine Daten enthalten!");
  fclose(v->file);
  FileClose(v);
  v->file=0;
  return 0;
  }

 if(Set)
 {
 v->Scale=(maximum-minimum)*1.2;
 /* Maximum aufrunden */
 sprintf(st1,"%E",v->Scale);
 sscanf(st1,"%d",&Mantisse);
 if(cp=strchr(st1,'E')) sscanf(cp+1,"%d",&Exponent);
 Mantisse+=1;
 sprintf(st1,"%d.0E%+d",Mantisse,Exponent);
 sscanf(st1,"%lf",&v->Scale);

 minimum-=v->Scale/10;
 /* Minimum abrunden */
 sprintf(st1,"%E",minimum);
 sscanf(st1,"%d",&Mantisse);
 if(cp=strchr(st1,'E')) sscanf(cp+1,"%d",&Exponent);
 //Mantisse-=1;
 sprintf(st1,"%d.0E%+d",Mantisse,Exponent);
 sscanf(st1,"%lf",&v->offset);
 if((v->offset<=0)&&(minimum0>=0)) v->offset=0;
 v->Aktzeit=v->Startzeit;
 laenge=v->Endzeit-v->Startzeit;
 v->Zoom=laenge;

 //fl_alert("nach Runden: Scale=%f, Offset=%f, Startzeit=%lf, Endzeit=%lf, %d Zeilen gelesen, Max=%lf, Min=%lf",v->Scale,v->offset,v->Startzeit,v->Endzeit,v->LineCount,maximum,minimum);

 }
 if(v->Scale==0) v->Scale=1;
 if(v->Zoom<0.0000001) v->Zoom=0.0000001;
 return v->LineCount;
}

int MyStrCmp(char *st1, char *st2)
 {
 /* Nicht case-sensitives strcmp */
 while ((*st1)||(*st2))
  {
  if(tolower(*st1)!=tolower(*st2)) return 1;
  st1++;
  st2++;
  }
 return 0;
 }

int LoadPalFile(myView *v, char* FileName)
 {
 int a;
 FILE *datei;
 char *cp,*cp1,*cp2,st1[MAXLINELENGTH];
 datei=fopen(FileName,"r");
 if(!datei) return -1;
 for(a=0;a<v->columns;a++)
  {
  cp=fgets(st1,300,datei);
  strcpy(v->column[a].name,cp);
  if(cp1=strchr(v->column[a].name,'#'))
   {
   *cp1=0;
   cp1++;
   sscanf(cp1,"%x",&v->column[a].color);
   if(cp1=strchr(cp1,'#'))
    {
    cp1++;
    sscanf(cp1,"%d",&v->column[a].active);
    v->column[a].act_def=v->column[a].active;
    if(cp1=strchr(cp1,'#'))
     {
     cp1++;
     cp2=strchr(cp1,'#');
     if(cp2) *cp2=0;
     strcpy(v->column[a].unit,cp1);
     if(cp2)
      {
       cp2++;
       cp1=strchr(cp2,'#');
       if(cp1) *cp1=0;
       sscanf(cp2,"%d",&v->column[a].style);
       if(cp1)
        {
        cp1++;
        sscanf(cp1,"%lf",&v->column[a].offset);
        }
      }
     }
    }
   }
  }
 fclose(datei);
 return 0;
 }

mru_rec *srchMru(char* name, myView *v){
	mru_rec *act;
	act=v->mru;
	while(act){
		if(!strcmp(name,act->name)) return act;
		act=act->next;
	}
	return 0;
}

int FileOpen(myView *v,char *name)
 {
 FILE *datei1=0;
 char st1[MAXLINELENGTH],TempFileName[300],*cp,*cp2,Datum1[20],Datum2[20];
 int a,c=0,jahr,monat,tag,stunde,minute,sekunde,Mantisse,Exponent,experimental=0,
     LineCount;
 float x,minimum=1E20;
 struct tm *tmBuf,t;
 time_t t1;
 mru_rec *mru;

 if(v->file)
  {
   FileClose(v); /* alte Datei schließen */
  }


	loadDefaults(v);
	/* versuchen, passende INI-Datei einzulesen */
	readConfigFile(getConfName(),v);

	/* Kommandozeilenparameter parsen */
	//ParseCmdLine();

	/* Quelldatei bei Bedarf konvertieren */
	strcpy(TempFileName,name);
	//Convert(name,TempFileName);    /* wenn nötig */
 datei1=fopen(TempFileName,"r");
 if(!datei1)
  {
  fl_alert("Datei konnte nicht geöffnet werden");
  return 0;
  }
 //Endzeit=0;
 //Startzeit=0x7fffffff;
 v->ActSeparatorChar=v->separator;
 /* vermutliche Kopfzeile, erstmalig lesen */
 cp=fgets(st1,MAXLINELENGTH,datei1);
 cp=strchr(st1,'\n');
 if(cp) *cp=0;
 //MessageBox(0,st1,"vermutliche Kopfzeile",MB_OK);

 if(v->separator=='A')
  {
  /* versuchen, Separatorzeichen zu erkennen */
  v->ActSeparatorChar='!';
  if(strchr(st1,',')) v->ActSeparatorChar=',';
  if(strchr(st1,';')) v->ActSeparatorChar=';';
  if(strchr(st1,'\t')) v->ActSeparatorChar='\t';
  }

 /* gibt es eine Kopfzeile? */
 if(v->HeadLines>0)
 {
 /* jetzt die Kopfzeile parsen (wie viele Spalten?) */
 if(cp=strchr(st1,'\r')) *cp=0; /* CR entfernen */
 cp=st1;
 /* Zeitformat prüfen? */
 if(!v->Zeitformat) /* Heimat-Dateiformat? */
  {
  if((strncmp(cp,"Datum",5))&&(strncmp(cp,"DATE",4)))
   {
   /* Versuchen, Format zu erkennen */
   experimental=1;
   v->Zeitformat=1;
   }
  }
 if(!v->Zeitformat)
  {
  /* Standard: zweite Spalte Uhrzeit überspringen*/
  parse(&cp,0,v);
  }
 /* Spalten zählen */
 v->columns=0;
 do
  {
  parse(&cp,0,v);
  v->columns++;
  }
 while ((cp)&&(strlen(cp)));
 v->columns--;
 }
 v->column=(colRec*)calloc(v->columns+2,sizeof(colRec));
 sprintf(v->Filterstring,"%%d.%%d.%%d%c%%d:%%d:%%lf",v->separator);

 /* Jetzt die Köpfe mit Standards befüllen */
 for(a=0;a<v->columns;a++)
  {
  int farbe,rot,gruen,blau;
  float winkel;
  const float pi   = 3.1418;
  sprintf(v->column[a].name,"Spalte %d",a+1);
  strcpy(v->column[a].unit,v->DefUnit);
  winkel=2*pi*a/v->columns;
  rot=127*(1+sin(winkel));
  gruen=127*(1+sin(winkel+(pi/3*2)));
  blau=127*(1+sin(winkel+2*(pi/3*2)));
  if(rot<0) rot=0;
  if(gruen<0) gruen=0;
  if(blau<0) blau=0;
  v->column[a].color=(rot<<24)+(gruen<<16)+(blau<<8)+255;
  v->column[a].active=v->column[a].act_def=1;
  v->column[a].style=0;
  v->column[a].offset=0;
  }

 /* Kopfdaten aus Kopfzeile lesen */
 if(v->HeadLines>0)
 {
 cp=st1+strlen(st1)+1; /*Das war das Datum*/
 if(!v->Zeitformat) cp=cp+strlen(cp)+1; /*Das war die Uhrzeit*/
 for(a=0;a<v->columns;a++)
  {
  char *cp1;

  strcpy(v->column[a].name,cp);
  if(cp1=strchr(v->column[a].name,'#'))
   {
   *cp1=0;
   cp1++;
   if(sscanf(cp1,"%x",&v->column[a].color)) v->column[a].color=(v->column[a].color<<8)+255;
   if(cp1=strchr(cp1,'#'))
    {
    cp1++;
    sscanf(cp1,"%d",&v->column[a].active);
    v->column[a].act_def=v->column[a].active;
    if(cp1=strchr(cp1,'#'))
     {
     cp1++;
     cp2=strchr(cp1,'#');
     if(cp2) *cp2=0;
     strcpy(v->column[a].unit,cp1);
     if(cp2)
      {
       cp2++;
       cp1=strchr(cp2,'#');
       if(cp1) *cp1=0;
       sscanf(cp2,"%d",&v->column[a].style);
       if(cp1)
        {
        cp1++;
        sscanf(cp1,"%lf",&v->column[a].offset);
        }
      }
     }
    }
   }
  cp=cp+strlen(cp)+1; /*weiterzählen*/
  }
 }
 if(strlen(v->PaletteFileName)) LoadPalFile(v,v->PaletteFileName);

 v->file=datei1;

/* haben wir die Datei in der MRU-Liste? */

 if(mru=srchMru(name,v))
 {
	/* gleiche Datei, wie letztesmal */
	v->Scale=mru->Scale;
	v->Zoom=mru->Zoom;
	v->Aktzeit=mru->Aktzeit;
	v->offset=mru->offset;
	v->LineCount=AutoScale(0,v);
 }
 else
 {
 LineCount=AutoScale(1,v);
 }
 if(0)
  {
  sprintf(st1,"Scale=%f, Offset=%f\nZeit: %lf bis %lf, Separator=<%c> (0x%02X), Zeilen= %d "
              "Auschalten dieser Meldung: Extras->Filter:Testmodus"
              ,v->Scale,v->offset,v->Startzeit,v->Endzeit,
			v->ActSeparatorChar,v->ActSeparatorChar,v->LineCount);
  fl_alert("Meldung:%s",st1);
  }
 /* Hauptfenster mit Dateinamen beschriften */
 sprintf(v->windowTitle,"%s - Ingos CSV-Viewer",name);
 strcpy(v->WorkFileName,name);
 main_win->label(v->windowTitle);

	/* maximale Länge Spaltenname */
	for(a=0;a<v->columns;a++){
		if(!v->longestColName) v->longestColName=v->column[a].name;
		else if(strlen(v->column[a].name)>strlen(v->longestColName)) v->longestColName=v->column[a].name;
	}
	/* erfolgreich */
	main_win->canvas->user_data(v);
	main_win->size(main_win->w(),main_win->h());
	main_win->redraw();
	statusOut(v->WorkFileName);
 return 0;
 }

