typedef struct transRec{
	transRec *next;
	char *orig, *trans,*remark;
} transRec;

transRec *transRoot,*transLast;

const char* gettext(const char* orig){
	transRec *act;
	act=transRoot;
	while(act){
		if(!strcmp(act->orig,orig)) return act->trans;
		act=act->next;
	}
	//printf("gettext not found: %s\n",orig);
	return orig;
}

void purgetext(void){
	transRec *act, *next;
	act=transRoot;
	while(act){
		next=act->next;
		free(act->orig);
		free(act->trans);
		free(act->remark);
		free(act);
		act=next;
	}
	transRoot=0;
	transLast=0;
}

void addtext(char *orig, char *trans,char *remark){
	char st1[20480];
	transRec *act;
	char *cp;
	cp=trans;
	while(cp=strstr(cp,"\\n")){
		strcpy(st1,cp+2);
		strcpy(cp,"\n");
		cp++;
		strcpy(cp,st1);
	}
	if(!strlen(trans)) strcpy(trans,orig);
	//printf("add %s -> %s\n",orig,trans);
	if(strlen(orig)){
		act=(transRec*)malloc(sizeof(transRec));
		act->next=0;
		act->orig=(char*)malloc(strlen(orig)+1);
		act->trans=(char*)malloc(strlen(trans)+1);
		act->remark=(char*)malloc(strlen(remark)+1);
		strcpy(act->orig,orig);
		strcpy(act->trans,trans);
		strcpy(act->remark,remark);
		orig[0]=0;
		trans[0]=0;
		if(transRoot) transLast->next=act;
		else transRoot=act;
		transLast=act;
	}
}

void loadtextfile(const char *filename){
	char st1[2048],orig[2048],trans[2048],remark[2048],*cp,*dp,dest;
	FILE *f;
	if(!strlen(filename)) return;
	f=fopen(filename,"r");
	if(!f){
		fl_alert("Language file not found: %s",filename);
		return;
		}
	while(fgets(st1,2020,f)){
		if(cp=strchr(st1,'\n')) *cp=0;
		if(cp=strrchr(st1,'"')) *cp=0;

		cp=st1;
		if(!strncmp(st1,"msgid",5)){
			orig[0]=0;
			dest=0;
			cp=st1+6;
			strcpy(orig,cp+1);
		}


		if(!strncmp(st1,"msgstr",6)){
			trans[0]=0;
			dest=1;
			cp=st1+7;
		}

		if(st1[0]=='#') strcpy(remark,st1);


	if(dest){
		if(*cp=='"') strcat(trans,cp+1);
	}

	if(!strlen(st1)) addtext(orig,trans,remark);
	}
	fclose(f);
	addtext(orig,trans,remark);
}
